.model small, c
.386

DrawLine PROTO :WORD,:WORD,:WORD,:WORD,:BYTE 

.stack
.data 
.code
.startup

SCREEN_WIDTH EQU 320
SCREEN_HEIGHT EQU 200

    mov   ax,13h
    int   10h
    ; Horizontal lines both directions:
    invoke DrawLine, 0, 0, 100, 0, 9
    invoke DrawLine, 100, 10, 0, 10, 9
    ; Vertical lines both directions:
    invoke DrawLine, 0, 20, 0, 120, 9
    invoke DrawLine, 10, 120, 10, 20, 9
    ; Diagonal both directions:
    invoke DrawLine, 50, 30, 150, 130, 4
    invoke DrawLine, 155, 130, 55, 30, 4
    invoke DrawLine, 50, 130, 150, 30, 4
    invoke DrawLine, 155, 30, 55, 130, 4
    ; Almost horizontal:
    invoke DrawLine, 0, 150, 319, 149, 15
    invoke DrawLine, 319, 151, 0, 150, 15
    ; Almost vertical:
    invoke DrawLine, 200, 0, 199, 199, 15
    invoke DrawLine, 201, 199, 200, 0, 15

    mov   ah, 0
    int   16h
    .exit

;       

SetPixel proc uses ax bx cx dx x:WORD, y:WORD, color:BYTE
    mov   ah, 0ch
    mov   bh, 0
    mov   al, color
    mov   cx, x
    mov   dx, y
    int   10h
    ret
SetPixel endp

;---------------------------
DrawLine PROC,
	x0:WORD,
	y0:WORD,
	x1:WORD,
	y1:WORD,
	color:BYTE
;
;	An implementation of the Bresenham line-drawing algorithm
;	Translated to ASM by ANW, 02/12/05
;---------------------------	
	LOCAL	deltax:WORD,
			deltay:WORD,
			error:WORD
		
	pusha
	
	; validate all the arguments (both coords are on screen)
	mov ax, SCREEN_WIDTH
	mov bx, SCREEN_HEIGHT
	xor cx, cx					; = 0

	cmp x0, cx
	jl DONE
	cmp x1, cx
	jl DONE
	cmp y0, cx
	jl DONE
	cmp y1, cx
	jl DONE
	
	cmp x0, ax
	jge DONE
	cmp x1, ax
	jge DONE
	cmp y0, bx
	jge DONE
	cmp y1, bx
	jge DONE

	;####################################
	;### START OF BRESENHAM ALGORITHM ###
	;####################################

	; cx = abs(y1 - y0) > abs(x1 - x0) ####################

	mov ax, y1
	sub ax, y0
	jns ABS_Y_DONE
	neg ax				; number is negative, so make it positive
	ABS_Y_DONE:
	
	mov bx, x1
	sub bx, x0
	jns ABS_X_DONE
	neg bx				; number is negative, so make it positive
	ABS_X_DONE:
	
	cmp ax, bx
	jbe ELSE1
		; ax > bx
		mov cx, 1
		jmp ENDIF1
	ELSE1:
		; ax <= bx
		mov cx, 0
	ENDIF1:

	; if cx then		####################

  bt cx, 0  
	jnc ELSE2
  
		; swap(x0, y0)
		mov ax, x0
		xchg ax, y0
		mov x0, ax
		
		; swap(x1, y1)
		mov ax, x1
		xchg ax, y1
		mov x1, ax
		
		INVOKE SetPixel, y0, x0, color
	ELSE2:
		INVOKE SetPixel, x0, y0, color
	ENDIF2:

	; deltax = abs(x1 - x0) ###########
	mov ax, x1
	sub ax, x0
	jns ABS_X2_DONE
	neg ax				; number is negative, so make it positive
	ABS_X2_DONE:
	mov deltax, ax

	; deltay = abs(y1 - y0) ###########
	mov ax, y1
	sub ax, y0
	jns ABS_Y2_DONE
	neg ax				; number is negative, so make it positive
	ABS_Y2_DONE:
	mov deltay, ax	

	; error = 0 ##########
	mov error, 0

	; bx = x0 #########
	mov bx, x0
	; dx = y0 #########
	mov dx, y0


	; if x0 < x1 then #########
	
	cmp bx, x1
	jae ELSE3
		;	si = 1
		mov si, 1
		jmp ENDIF3
	ELSE3:
		;	si = -1
		mov si, -1
	ENDIF3:

	; if y0 < y1 then #########
	
	cmp dx, y1
	jae ELSE4
		;	di = 1
		mov di, 1
		jmp ENDIF4
	ELSE4:
		;	di = -1
		mov di, -1
	ENDIF4:

	; while bx != x1 ###############
	L1:
		cmp bx, x1
		je DONE

		; bx = bx + si
		add bx, si

		; error = error + deltay
		mov ax, error
		add ax, deltay
		mov error, ax

		; if 2 * error > deltax	##########
		; (error value is still in ax...)
		
		shl ax, 1				;error * 2
		cmp ax, deltax
		jbe ENDIF5
			; dx = dx + di
			;add dx, di
      
			; error = error - deltax
			mov ax, deltax
			sub error, ax
		ENDIF5:

		; if cx then			#############
		bt cx, 0
		jnc ELSE6
			; plot(dx,bx)
			INVOKE SetPixel, dx, bx, color
			jmp L1				; SHORTCUT TO BEGINNING OF WHILE LOOP
		ELSE6:
			; plot(bx,dx)
			INVOKE SetPixel, bx, dx, color
		
	jmp L1						; continue the while loop
	
	DONE:
		popa
		ret
DrawLine ENDP
; 
end
